package logic

import (
	"GtDataStore/app/model"
	"context"
	"github.com/jinzhu/copier"

	"GtDataStore/app/cmd/organization/internal/svc"
	"GtDataStore/app/cmd/organization/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetWorkingChestByCodeLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetWorkingChestByCodeLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetWorkingChestByCodeLogic {
	return &GetWorkingChestByCodeLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *GetWorkingChestByCodeLogic) GetWorkingChestByCode(in *pb.DcWorkingReq) (*pb.WorkingChest, error) {
	//基础条件
	workingChestInfo, err := l.svcCtx.WorkingChest.FindOneByCode(l.ctx, in.ProjectId, in.DeviceCode)
	if err != nil && err != model.ErrNotFound {
		logx.Errorf("not found workingUf data")
		return nil, err
	}

	resp := &pb.WorkingChest{}
	_ = copier.Copy(resp, workingChestInfo)
	resp.CTime = workingChestInfo.CTime.Format("2006-01-02 15:04:05")

	return resp, nil
}
