package logic

import (
	"GtDataStore/app/cmd/organization/internal/svc"
	"GtDataStore/app/cmd/organization/pb"
	"GtDataStore/app/model"
	"context"
	"github.com/jinzhu/copier"

	"github.com/zeromicro/go-zero/core/logx"
)

type GetWorkingUfByCodeLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewGetWorkingUfByCodeLogic(ctx context.Context, svcCtx *svc.ServiceContext) *GetWorkingUfByCodeLogic {
	return &GetWorkingUfByCodeLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *GetWorkingUfByCodeLogic) GetWorkingUfByCode(in *pb.DcWorkingReq) (*pb.WorkingUf, error) {
	//基础条件
	workingUfInfo, err := l.svcCtx.WorkingUf.FindOneByCode(l.ctx, in.ProjectId, in.DeviceCode)
	if err != nil && err != model.ErrNotFound {
		logx.Errorf("not found workingUf data")
		return nil, err
	}

	resp := &pb.WorkingUf{}
	_ = copier.Copy(resp, workingUfInfo)
	resp.CTime = workingUfInfo.CTime.Format("2006-01-02 15:04:05")

	return resp, nil
}
