// Code generated by goctl. DO NOT EDIT.

package model

import (
	"context"
	"database/sql"
	"fmt"
	"strings"
	"time"

	"github.com/zeromicro/go-zero/core/stores/builder"
	"github.com/zeromicro/go-zero/core/stores/sqlc"
	"github.com/zeromicro/go-zero/core/stores/sqlx"
	"github.com/zeromicro/go-zero/core/stringx"
)

var (
	dcAlarmListFieldNames          = builder.RawFieldNames(&DcAlarmList{})
	dcAlarmListRows                = strings.Join(dcAlarmListFieldNames, ",")
	dcAlarmListRowsExpectAutoSet   = strings.Join(stringx.Remove(dcAlarmListFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), ",")
	dcAlarmListRowsWithPlaceHolder = strings.Join(stringx.Remove(dcAlarmListFieldNames, "`id`", "`create_at`", "`create_time`", "`created_at`", "`update_at`", "`update_time`", "`updated_at`"), "=?,") + "=?"
)

type (
	dcAlarmListModel interface {
		Insert(ctx context.Context, data *DcAlarmList) (sql.Result, error)
		FindOne(ctx context.Context, id int64) (*DcAlarmList, error)
		Update(ctx context.Context, data *DcAlarmList) error
		Delete(ctx context.Context, id int64) error
	}

	defaultDcAlarmListModel struct {
		conn  sqlx.SqlConn
		table string
	}

	DcAlarmList struct {
		Id         int64     `db:"id"`
		ProjectId  int64     `db:"project_id"`
		DeviceCode string    `db:"device_code"`
		Item       string    `db:"item"`
		Val        string    `db:"val"`      // 报警发生时，点位的值
		AlarmId    int64     `db:"alarm_id"` // 报警 ID dc_alarm_bind.id
		Title      string    `db:"title"`    // 报警标题
		Context    string    `db:"context"`  // 报警内容
		CTime      time.Time `db:"c_time"`
	}
)

func newDcAlarmListModel(conn sqlx.SqlConn) *defaultDcAlarmListModel {
	return &defaultDcAlarmListModel{
		conn:  conn,
		table: "`dc_alarm_list`",
	}
}

func (m *defaultDcAlarmListModel) withSession(session sqlx.Session) *defaultDcAlarmListModel {
	return &defaultDcAlarmListModel{
		conn:  sqlx.NewSqlConnFromSession(session),
		table: "`dc_alarm_list`",
	}
}

func (m *defaultDcAlarmListModel) Delete(ctx context.Context, id int64) error {
	query := fmt.Sprintf("delete from %s where `id` = ?", m.table)
	_, err := m.conn.ExecCtx(ctx, query, id)
	return err
}

func (m *defaultDcAlarmListModel) FindOne(ctx context.Context, id int64) (*DcAlarmList, error) {
	query := fmt.Sprintf("select %s from %s where `id` = ? limit 1", dcAlarmListRows, m.table)
	var resp DcAlarmList
	err := m.conn.QueryRowCtx(ctx, &resp, query, id)
	switch err {
	case nil:
		return &resp, nil
	case sqlc.ErrNotFound:
		return nil, ErrNotFound
	default:
		return nil, err
	}
}

func (m *defaultDcAlarmListModel) Insert(ctx context.Context, data *DcAlarmList) (sql.Result, error) {
	query := fmt.Sprintf("insert into %s (%s) values (?, ?, ?, ?, ?, ?, ?, ?)", m.table, dcAlarmListRowsExpectAutoSet)
	ret, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Item, data.Val, data.AlarmId, data.Title, data.Context, data.CTime)
	return ret, err
}

func (m *defaultDcAlarmListModel) Update(ctx context.Context, data *DcAlarmList) error {
	query := fmt.Sprintf("update %s set %s where `id` = ?", m.table, dcAlarmListRowsWithPlaceHolder)
	_, err := m.conn.ExecCtx(ctx, query, data.ProjectId, data.DeviceCode, data.Item, data.Val, data.AlarmId, data.Title, data.Context, data.CTime, data.Id)
	return err
}

func (m *defaultDcAlarmListModel) tableName() string {
	return m.table
}
